
/*****************************************************************************/
/*                                                                           */
/* Unification avec controle d'occurence                                     */
/*                                                                           */
/*****************************************************************************/

:-module(unify,
	[
		'*='/2			% unification
	]
).

:-op(700,xfx,*=).
:-op(700,xfx,has_no).

/*****************************************************************************/
/*                                                                           */
/* Unification avec controle d'occurence                                     */
/*                                                                           */
/*****************************************************************************/

X *= Y :-
	( var(X)
	->	( var(Y)
		->	X=Y
		;	Y has_no X,
			X=Y
		)
	;	( var(Y)
		->	X has_no Y,
			Y=X
		;	functor(X,F,N),
			functor(Y,F,N),
			unify_args(N,X,Y)
		)
	).

Term has_no Var :-
	( var(Term)
	->	Var\==Term
	;	functor(Term,_,Arity),
		has_no(Arity,Term,Var)
	).

has_no(0,_,_):-!.
has_no(N,Term,Var):-
	arg(N,Term,Arg),
	Arg has_no Var,
	N1 is N-1,
	has_no(N1,Term,Var).

unify_args(0,_,_):-!.
unify_args(N,X,Y):-
	arg(N,X,Xn),
	arg(N,Y,Yn),
	Xn*=Yn,
	N1 is N-1,
	unify_args(N1,X,Y).

